2019-01-28 02:40:11 +08:00
#!/usr/bin/env bash
2017-06-20 05:31:43 +08:00
2019-01-29 19:13:04 +08:00
# Check permissions
if [ " $( id -u) " -ne "0" ] ; then
echo "You need to be root"
exit 1
fi
2019-03-03 06:48:20 +08:00
# Exit on error and pipefail
2018-02-20 16:31:01 +08:00
set -o pipefail
2019-05-26 04:29:25 +08:00
# Setting high dc timeout
2019-05-26 04:37:51 +08:00
export COMPOSE_HTTP_TIMEOUT = 600
2019-05-26 04:29:25 +08:00
2019-03-03 06:48:20 +08:00
# Add /opt/bin to PATH
PATH = $PATH :/opt/bin
2018-07-13 19:06:56 +08:00
umask 0022
2017-09-08 16:02:50 +08:00
for bin in curl docker-compose docker git awk sha1sum; do
2018-01-24 16:24:40 +08:00
if [ [ -z $( which ${ bin } ) ] ] ; then echo " Cannot find ${ bin } , exiting... " ; exit 1; fi
2017-09-08 16:02:50 +08:00
done
2017-06-24 06:04:05 +08:00
2018-02-01 16:40:08 +08:00
export LC_ALL = C
DATE = $( date +%Y-%m-%d_%H_%M_%S)
BRANCH = $( git rev-parse --abbrev-ref HEAD)
2019-07-09 00:42:51 +08:00
function prefetch_images( ) {
2019-07-09 00:45:57 +08:00
[ [ -z ${ BRANCH } ] ] && { echo -e "\e[33m\nUnknown branch...\e[0m" ; exit 1; }
while read image; do
RET_C = 0
until docker pull ${ image } ; do
RET_C = $(( RET_C + 1 ))
echo -e " \e[33m\nError pulling $image , retrying...\e[0m "
[ ${ RET_C } -gt 3 ] && { echo -e "\e[31m\nToo many failed retries, exiting\e[0m" ; exit 1; }
sleep 1
done
done < <( git show origin/${ BRANCH } :docker-compose.yml | grep "image:" | awk '{ gsub("image:","", $3); print $2 }' )
2019-07-09 00:42:51 +08:00
}
2018-07-25 07:08:12 +08:00
docker_garbage( ) {
IMGS_TO_DELETE = ( )
for container in $( grep -oP "image: \Kmailcow.+" docker-compose.yml) ; do
REPOSITORY = ${ container / : * }
TAG = ${ container /* : }
V_MAIN = ${ container /*. }
V_SUB = ${ container /*. }
EXISTING_TAGS = $( docker images | grep ${ REPOSITORY } | awk '{ print $2 }' )
for existing_tag in ${ EXISTING_TAGS [@] } ; do
V_MAIN_EXISTING = ${ existing_tag /*. }
V_SUB_EXISTING = ${ existing_tag /*. }
# Not an integer
[ [ ! $V_MAIN_EXISTING = ~ ^[ 0-9] +$ ] ] && continue
[ [ ! $V_SUB_EXISTING = ~ ^[ 0-9] +$ ] ] && continue
if [ [ $V_MAIN_EXISTING = = "latest" ] ] ; then
echo " Found deprecated label \"latest\" for repository $REPOSITORY , it should be deleted. "
IMGS_TO_DELETE += ( $REPOSITORY :$existing_tag )
elif [ [ $V_MAIN_EXISTING -lt $V_MAIN ] ] ; then
echo " Found tag $existing_tag for $REPOSITORY , which is older than the current tag $TAG and should be deleted. "
IMGS_TO_DELETE += ( $REPOSITORY :$existing_tag )
elif [ [ $V_SUB_EXISTING -lt $V_SUB ] ] ; then
echo " Found tag $existing_tag for $REPOSITORY , which is older than the current tag $TAG and should be deleted. "
IMGS_TO_DELETE += ( $REPOSITORY :$existing_tag )
fi
done
done
if [ [ ! -z ${ IMGS_TO_DELETE [*] } ] ] ; then
echo "Run the following command to delete unused image tags:"
echo
echo " docker rmi ${ IMGS_TO_DELETE [*] } "
echo
read -r -p "Do you want to delete old image tags right now? [y/N] " response
if [ [ " $response " = ~ ^( [ yY] [ eE] [ sS] | [ yY] ) +$ ] ] ; then
docker rmi ${ IMGS_TO_DELETE [*] }
else
echo "OK, skipped."
fi
fi
echo -e "\e[32mFurther cleanup...\e[0m"
echo "If you want to cleanup further garbage collected by Docker, please make sure all containers are up and running before cleaning your system by executing \"docker system prune\""
}
2018-02-01 16:40:08 +08:00
while ( ( $# ) ) ; do
case " ${ 1 } " in
--check| -c)
echo "Checking remote code for updates..."
2018-11-16 19:09:55 +08:00
LATEST_REV = $( git ls-remote --exit-code --refs --quiet https://github.com/mailcow/mailcow-dockerized ${ BRANCH } | cut -f1)
if [ $? -ne 0 ] ; then
echo "A problem occurred while trying to fetch the latest revision from github."
exit 99
2019-03-13 00:21:45 +08:00
fi
2018-11-16 19:09:55 +08:00
if [ [ -z $( git log HEAD --pretty= format:"%H" | grep " ${ LATEST_REV } " ) ] ] ; then
2018-02-01 16:40:08 +08:00
echo "Updated code is available."
exit 0
else
echo "No updates available."
exit 3
fi
; ;
--ours)
MERGE_STRATEGY = ours
; ;
2018-07-25 07:08:12 +08:00
--gc)
2018-10-03 18:34:10 +08:00
echo -e "\e[32mCollecting garbage...\e[0m"
2018-07-25 07:08:12 +08:00
docker_garbage
exit 0
; ;
2019-07-09 00:42:51 +08:00
--prefetch)
echo -e "\e[32mPrefetching images...\e[0m"
prefetch_images
exit 0
; ;
2018-07-25 07:08:12 +08:00
--help| -h)
echo ' ./update.sh [ -c| --check, --ours, --gc, -h| --help]
-c| --check - Check for updates and exit ( exit codes = > 0: update available, 3: no updates)
--ours - Use merge strategy "ours" to solve conflicts in favor of non-mailcow code ( local changes)
--gc - Run garbage collector to delete old image tags
'
exit 1
2018-02-01 16:40:08 +08:00
esac
2018-07-04 21:10:30 +08:00
shift
2018-02-01 16:40:08 +08:00
done
2018-01-09 05:00:54 +08:00
[ [ ! -f mailcow.conf ] ] && { echo "mailcow.conf is missing" ; exit 1; }
2019-03-13 06:23:38 +08:00
chmod 600 mailcow.conf
2018-07-12 01:59:21 +08:00
source mailcow.conf
DOTS = ${ MAILCOW_HOSTNAME //[^.] } ;
if [ ${# DOTS } -lt 2 ] ; then
echo " MAILCOW_HOSTNAME ( ${ MAILCOW_HOSTNAME } ) is not a FQDN! "
echo "Please change it to a FQDN and run docker-compose down followed by docker-compose up -d"
exit 1
fi
2018-01-09 05:00:54 +08:00
2018-02-20 16:31:01 +08:00
if grep --help 2>& 1 | head -n 1 | grep -q -i "busybox" ; then echo "BusybBox grep detected, please install gnu grep, \"apk add --no-cache --upgrade grep\"" ; exit 1; fi
if cp --help 2>& 1 | head -n 1 | grep -q -i "busybox" ; then echo "BusybBox cp detected, please install coreutils, \"apk add --no-cache --upgrade coreutils\"" ; exit 1; fi
2018-02-01 16:40:08 +08:00
CONFIG_ARRAY = (
"SKIP_LETS_ENCRYPT"
"USE_WATCHDOG"
"WATCHDOG_NOTIFY_EMAIL"
2019-06-16 03:55:23 +08:00
"WATCHDOG_NOTIFY_BAN"
2018-02-01 16:40:08 +08:00
"SKIP_CLAMD"
"SKIP_IP_CHECK"
"ADDITIONAL_SAN"
"DOVEADM_PORT"
"IPV4_NETWORK"
"IPV6_NETWORK"
"LOG_LINES"
"SNAT_TO_SOURCE"
2018-07-12 01:41:04 +08:00
"SNAT6_TO_SOURCE"
2018-04-28 03:00:06 +08:00
"COMPOSE_PROJECT_NAME"
2018-04-29 15:27:29 +08:00
"SQL_PORT"
2018-06-08 15:11:03 +08:00
"API_KEY"
"API_ALLOW_FROM"
2018-10-03 03:24:22 +08:00
"MAILDIR_GC_TIME"
2019-03-19 02:49:05 +08:00
"MAILDIR_SUB"
2018-11-18 20:31:09 +08:00
"ACL_ANYONE"
2019-01-16 17:50:34 +08:00
"SOLR_HEAP"
"SKIP_SOLR"
2019-02-24 00:59:18 +08:00
"ALLOW_ADMIN_EMAIL_LOGIN"
2019-03-29 14:48:31 +08:00
"SKIP_HTTP_VERIFICATION"
2019-07-21 19:07:48 +08:00
"SOGO_EXPIRE_SESSION"
2018-02-01 16:40:08 +08:00
)
2018-01-09 05:00:54 +08:00
sed -i '$a\' mailcow.conf
2017-07-05 03:28:27 +08:00
for option in ${ CONFIG_ARRAY [@] } ; do
2018-01-24 16:24:40 +08:00
if [ [ ${ option } = = "ADDITIONAL_SAN" ] ] ; then
if ! grep -q ${ option } mailcow.conf; then
echo " Adding new option \" ${ option } \" to mailcow.conf "
echo " ${ option } = " >> mailcow.conf
fi
elif [ [ ${ option } = = "COMPOSE_PROJECT_NAME" ] ] ; then
if ! grep -q ${ option } mailcow.conf; then
echo " Adding new option \" ${ option } \" to mailcow.conf "
2018-04-13 20:13:24 +08:00
echo "COMPOSE_PROJECT_NAME=mailcowdockerized" >> mailcow.conf
2018-01-24 16:24:40 +08:00
fi
elif [ [ ${ option } = = "DOVEADM_PORT" ] ] ; then
if ! grep -q ${ option } mailcow.conf; then
echo " Adding new option \" ${ option } \" to mailcow.conf "
echo "DOVEADM_PORT=127.0.0.1:19991" >> mailcow.conf
fi
elif [ [ ${ option } = = "WATCHDOG_NOTIFY_EMAIL" ] ] ; then
if ! grep -q ${ option } mailcow.conf; then
echo " Adding new option \" ${ option } \" to mailcow.conf "
echo "WATCHDOG_NOTIFY_EMAIL=" >> mailcow.conf
fi
2018-01-09 05:00:54 +08:00
elif [ [ ${ option } = = "LOG_LINES" ] ] ; then
if ! grep -q ${ option } mailcow.conf; then
echo " Adding new option \" ${ option } \" to mailcow.conf "
2018-01-24 16:24:40 +08:00
echo '# Max log lines per service to keep in Redis logs' >> mailcow.conf
2018-01-09 05:00:54 +08:00
echo "LOG_LINES=9999" >> mailcow.conf
fi
2018-01-24 16:24:40 +08:00
elif [ [ ${ option } = = "IPV4_NETWORK" ] ] ; then
if ! grep -q ${ option } mailcow.conf; then
echo " Adding new option \" ${ option } \" to mailcow.conf "
echo '# Internal IPv4 /24 subnet, format n.n.n. (expands to n.n.n.0/24)' >> mailcow.conf
echo "IPV4_NETWORK=172.22.1" >> mailcow.conf
fi
elif [ [ ${ option } = = "IPV6_NETWORK" ] ] ; then
if ! grep -q ${ option } mailcow.conf; then
echo " Adding new option \" ${ option } \" to mailcow.conf "
2018-02-01 16:40:08 +08:00
echo '# Internal IPv6 subnet in fc00::/7' >> mailcow.conf
2018-01-24 16:24:40 +08:00
echo "IPV6_NETWORK=fd4d:6169:6c63:6f77::/64" >> mailcow.conf
fi
2018-02-06 04:42:13 +08:00
elif [ [ ${ option } = = "SQL_PORT" ] ] ; then
if ! grep -q ${ option } mailcow.conf; then
echo " Adding new option \" ${ option } \" to mailcow.conf "
echo '# Bind SQL to 127.0.0.1 on port 13306' >> mailcow.conf
echo "SQL_PORT=127.0.0.1:13306" >> mailcow.conf
fi
2018-06-08 15:11:03 +08:00
elif [ [ ${ option } = = "API_KEY" ] ] ; then
if ! grep -q ${ option } mailcow.conf; then
echo " Adding new option \" ${ option } \" to mailcow.conf "
echo '# Create or override API key for web UI' >> mailcow.conf
echo "#API_KEY=" >> mailcow.conf
fi
elif [ [ ${ option } = = "API_ALLOW_FROM" ] ] ; then
if ! grep -q ${ option } mailcow.conf; then
echo " Adding new option \" ${ option } \" to mailcow.conf "
echo '# Must be set for API_KEY to be active' >> mailcow.conf
echo "#API_ALLOW_FROM=" >> mailcow.conf
fi
2018-02-01 16:40:08 +08:00
elif [ [ ${ option } = = "SNAT_TO_SOURCE" ] ] ; then
if ! grep -q ${ option } mailcow.conf; then
echo " Adding new option \" ${ option } \" to mailcow.conf "
2018-07-12 01:41:04 +08:00
echo '# Use this IPv4 for outgoing connections (SNAT)' >> mailcow.conf
2018-02-01 16:40:08 +08:00
echo "#SNAT_TO_SOURCE=" >> mailcow.conf
fi
2018-07-12 01:41:04 +08:00
elif [ [ ${ option } = = "SNAT6_TO_SOURCE" ] ] ; then
if ! grep -q ${ option } mailcow.conf; then
echo " Adding new option \" ${ option } \" to mailcow.conf "
echo '# Use this IPv6 for outgoing connections (SNAT)' >> mailcow.conf
echo "#SNAT6_TO_SOURCE=" >> mailcow.conf
fi
2018-09-30 20:49:19 +08:00
elif [ [ ${ option } = = "MAILDIR_GC_TIME" ] ] ; then
if ! grep -q ${ option } mailcow.conf; then
echo " Adding new option \" ${ option } \" to mailcow.conf "
echo '# Garbage collector cleanup' >> mailcow.conf
echo '# Deleted domains and mailboxes are moved to /var/vmail/_garbage/timestamp_sanitizedstring' >> mailcow.conf
echo '# How long should objects remain in the garbage until they are being deleted? (value in minutes)' >> mailcow.conf
2018-10-02 15:32:51 +08:00
echo '# Check interval is hourly' >> mailcow.conf
2018-09-30 20:49:19 +08:00
echo 'MAILDIR_GC_TIME=1440' >> mailcow.conf
fi
2018-11-18 20:31:09 +08:00
elif [ [ ${ option } = = "ACL_ANYONE" ] ] ; then
if ! grep -q ${ option } mailcow.conf; then
echo " Adding new option \" ${ option } \" to mailcow.conf "
2019-01-18 02:44:52 +08:00
echo '# Set this to "allow" to enable the anyone pseudo user. Disabled by default.' >> mailcow.conf
echo '# When enabled, ACL can be created, that apply to "All authenticated users"' >> mailcow.conf
echo '# This should probably only be activated on mail hosts, that are used exclusivly by one organisation.' >> mailcow.conf
echo '# Otherwise a user might share data with too many other users.' >> mailcow.conf
2018-11-18 20:31:09 +08:00
echo 'ACL_ANYONE=disallow' >> mailcow.conf
fi
2019-01-16 17:50:34 +08:00
elif [ [ ${ option } = = "SOLR_HEAP" ] ] ; then
if ! grep -q ${ option } mailcow.conf; then
echo " Adding new option \" ${ option } \" to mailcow.conf "
echo '# Solr heap size, there is no recommendation, please see Solr docs.' >> mailcow.conf
2019-01-18 02:44:52 +08:00
echo '# Solr is a prone to run OOM on large systems and should be monitored. Unmonitored Solr setups are not recommended.' >> mailcow.conf
2019-01-18 03:25:38 +08:00
echo '# Solr will refuse to start with total system memory below or equal to 2 GB.' >> mailcow.conf
2019-01-16 17:50:34 +08:00
echo "SOLR_HEAP=1024" >> mailcow.conf
fi
2019-01-20 05:00:18 +08:00
elif [ [ ${ option } = = "SKIP_SOLR" ] ] ; then
if ! grep -q ${ option } mailcow.conf; then
echo " Adding new option \" ${ option } \" to mailcow.conf "
echo '# Solr is disabled by default after upgrading from non-Solr to Solr-enabled mailcows.' >> mailcow.conf
2019-01-29 20:29:30 +08:00
echo '# Disable Solr or if you do not want to store a readable index of your mails in solr-vol-1.' >> mailcow.conf
2019-01-20 05:00:18 +08:00
echo "SKIP_SOLR=y" >> mailcow.conf
fi
2019-03-18 21:09:32 +08:00
elif [ [ ${ option } = = "MAILDIR_SUB" ] ] ; then
if ! grep -q ${ option } mailcow.conf; then
echo " Adding new option \" ${ option } \" to mailcow.conf "
echo '# MAILDIR_SUB defines a path in a users virtual home to keep the maildir in. Leave empty for updated setups.' >> mailcow.conf
2019-03-19 02:49:05 +08:00
echo "#MAILDIR_SUB=Maildir" >> mailcow.conf
2019-03-18 21:09:32 +08:00
echo "MAILDIR_SUB=" >> mailcow.conf
fi
2019-06-14 01:38:53 +08:00
elif [ [ ${ option } = = "WATCHDOG_NOTIFY_BAN" ] ] ; then
if ! grep -q ${ option } mailcow.conf; then
echo " Adding new option \" ${ option } \" to mailcow.conf "
echo '# Notify about banned IP. Includes whois lookup.' >> mailcow.conf
echo "WATCHDOG_NOTIFY_BAN=y" >> mailcow.conf
2019-07-21 19:07:48 +08:00
fi
elif [ [ ${ option } = = "SOGO_EXPIRE_SESSION" ] ] ; then
if ! grep -q ${ option } mailcow.conf; then
echo " Adding new option \" ${ option } \" to mailcow.conf "
echo '# SOGo session timeout in minutes' >> mailcow.conf
echo "SOGO_EXPIRE_SESSION=480" >> mailcow.conf
2019-06-14 01:38:53 +08:00
fi
2018-01-24 16:24:40 +08:00
elif ! grep -q ${ option } mailcow.conf; then
echo " Adding new option \" ${ option } \" to mailcow.conf "
echo " ${ option } =n " >> mailcow.conf
fi
2017-07-05 03:28:27 +08:00
done
2017-06-21 04:17:41 +08:00
echo -en "Checking internet connection... "
2019-05-12 20:40:54 +08:00
timeout 3 ping -c 1 9.9.9.9 > /dev/null
2017-06-21 04:17:41 +08:00
if [ [ $? != 0 ] ] ; then
2018-01-24 16:24:40 +08:00
echo -e "\e[31mfailed\e[0m"
exit 1
2018-02-20 16:31:01 +08:00
else
2018-01-24 16:24:40 +08:00
echo -e "\e[32mOK\e[0m"
2017-06-21 04:17:41 +08:00
fi
2017-06-21 17:48:03 +08:00
echo -e "\e[32mChecking for newer update script...\e[0m"
2017-06-21 22:44:57 +08:00
SHA1_1 = $( sha1sum update.sh)
2018-04-26 03:58:50 +08:00
git fetch origin #${BRANCH}
2017-06-21 22:44:57 +08:00
git checkout origin/${ BRANCH } update.sh
SHA1_2 = $( sha1sum update.sh)
if [ [ ${ SHA1_1 } != ${ SHA1_2 } ] ] ; then
2018-01-24 16:24:40 +08:00
echo "update.sh changed, please run this script again, exiting."
chmod +x update.sh
exit 0
2017-06-21 05:41:25 +08:00
fi
2017-06-21 04:17:41 +08:00
2017-06-21 03:40:15 +08:00
if [ [ -f mailcow.conf ] ] ; then
2018-01-24 16:24:40 +08:00
source mailcow.conf
2018-02-20 16:31:01 +08:00
else
2018-01-24 16:24:40 +08:00
echo -e "\e[31mNo mailcow.conf - is mailcow installed?\e[0m"
exit 1
2017-06-21 03:40:15 +08:00
fi
2017-06-20 05:31:43 +08:00
2017-11-23 17:02:25 +08:00
read -r -p "Are you sure you want to update mailcow: dockerized? All containers will be stopped. [y/N] " response
2017-06-21 05:05:43 +08:00
if [ [ ! " $response " = ~ ^( [ yY] [ eE] [ sS] | [ yY] ) +$ ] ] ; then
2018-01-24 16:24:40 +08:00
echo "OK, exiting."
exit 0
2017-06-21 05:05:43 +08:00
fi
2019-05-26 04:29:25 +08:00
echo -e "\e[32mPrefetching images...\e[0m"
2019-07-09 00:42:51 +08:00
prefetch_images
2019-05-26 04:29:25 +08:00
2017-09-17 05:24:30 +08:00
echo -e "Stopping mailcow... "
sleep 2
docker-compose down
2017-06-21 03:21:21 +08:00
2017-06-20 05:31:43 +08:00
# Silently fixing remote url from andryyy to mailcow
git remote set-url origin https://github.com/mailcow/mailcow-dockerized
2017-06-21 17:48:03 +08:00
echo -e "\e[32mCommitting current status...\e[0m"
2018-12-22 23:56:50 +08:00
[ [ -z " $( git config user.name) " ] ] && git config user.name moo
[ [ -z " $( git config user.email) " ] ] && git config user.email moo@cow.moo
2019-06-11 04:44:10 +08:00
[ [ ! -z $( git ls-files data/conf/rspamd/override.d/worker-controller-password.inc) ] ] && git rm data/conf/rspamd/override.d/worker-controller-password.inc
2017-06-20 05:31:43 +08:00
git add -u
git commit -am " Before update on ${ DATE } " > /dev/null
2017-06-21 17:48:03 +08:00
echo -e "\e[32mFetching updated code from remote...\e[0m"
2018-04-26 03:58:50 +08:00
git fetch origin #${BRANCH}
2018-02-01 16:40:08 +08:00
echo -e " \e[32mMerging local with remote code (recursive, strategy: \" ${ MERGE_STRATEGY :- theirs } \", options: \"patience\"...\e[0m "
2017-09-14 01:25:54 +08:00
git config merge.defaultToUpstream true
2018-02-01 16:40:08 +08:00
git merge -X${ MERGE_STRATEGY :- theirs } -Xpatience -m " After update on ${ DATE } "
2017-06-21 17:57:32 +08:00
# Need to use a variable to not pass return codes of if checks
MERGE_RETURN = $?
if [ [ ${ MERGE_RETURN } = = 128 ] ] ; then
2018-01-24 16:24:40 +08:00
echo -e "\e[31m\nOh no, what happened?\n=> You most likely added files to your local mailcow instance that were now added to the official mailcow repository. Please move them to another location before updating mailcow.\e[0m"
exit 1
2017-06-21 17:57:32 +08:00
elif [ [ ${ MERGE_RETURN } = = 1 ] ] ; then
2018-01-24 16:24:40 +08:00
echo -e "\e[93mPotenial conflict, trying to fix...\e[0m"
git status --porcelain | grep -E "UD|DU" | awk '{print $2}' | xargs rm -v
git add -A
git commit -m " After update on ${ DATE } " > /dev/null
git checkout .
echo -e "\e[32mRemoved and recreated files if necessary.\e[0m"
2017-06-21 17:57:32 +08:00
elif [ [ ${ MERGE_RETURN } != 0 ] ] ; then
2018-01-24 16:24:40 +08:00
echo -e "\e[31m\nOh no, something went wrong. Please check the error message above.\e[0m"
echo
echo "Run docker-compose up -d to restart your stack without updates or try again after fixing the mentioned errors."
exit 1
2017-06-20 05:31:43 +08:00
fi
2017-07-08 22:22:48 +08:00
echo -e "\e[32mFetching new docker-compose version...\e[0m"
sleep 2
2018-02-20 16:31:01 +08:00
if [ [ ! -z $( which pip) && $( pip list --local | grep -c docker-compose) = = 1 ] ] ; then
true
#prevent breaking a working docker-compose installed with pip
elif [ [ $( curl -sL -w "%{http_code}" https://www.servercow.de/docker-compose/latest.php -o /dev/null) = = "200" ] ] ; then
2018-01-24 16:24:40 +08:00
LATEST_COMPOSE = $( curl -#L https://www.servercow.de/docker-compose/latest.php)
2018-04-29 15:22:00 +08:00
COMPOSE_VERSION = $( docker-compose version --short)
if [ [ " $LATEST_COMPOSE " != " $COMPOSE_VERSION " ] ] ; then
if [ [ -w $( which docker-compose) ] ] ; then
curl -#L https://github.com/docker/compose/releases/download/${ LATEST_COMPOSE } /docker-compose-$( uname -s) -$( uname -m) > $( which docker-compose)
chmod +x $( which docker-compose)
else
echo -e " \e[33mWARNING: $( which docker-compose) is not writable, but new version $LATEST_COMPOSE is available (installed: $COMPOSE_VERSION )\e[0m "
fi
fi
2018-02-20 16:31:01 +08:00
else
2018-01-24 16:24:40 +08:00
echo -e "\e[33mCannot determine latest docker-compose version, skipping...\e[0m"
2017-07-08 22:22:48 +08:00
fi
2017-06-21 03:21:21 +08:00
echo -e "\e[32mFetching new images, if any...\e[0m"
2017-06-21 22:53:36 +08:00
sleep 2
2018-04-29 15:22:00 +08:00
docker-compose pull
2017-06-21 05:22:39 +08:00
2017-06-21 03:40:15 +08:00
# Fix missing SSL, does not overwrite existing files
[ [ ! -d data/assets/ssl ] ] && mkdir -p data/assets/ssl
cp -n data/assets/ssl-example/*.pem data/assets/ssl/
2017-06-21 04:17:41 +08:00
2018-07-25 07:08:12 +08:00
echo -e "Checking IPv6 settings... "
if grep -q 'SYSCTL_IPV6_DISABLED=1' mailcow.conf; then
echo
echo '!! IMPORTANT !!'
echo
2019-06-03 02:56:08 +08:00
echo 'SYSCTL_IPV6_DISABLED was removed due to complications. IPv6 can be disabled by editing "docker-compose.yml" and setting "enable_ipv6: true" to "enable_ipv6: false".'
2018-07-25 07:08:12 +08:00
echo 'This setting will only be active after a complete shutdown of mailcow by running "docker-compose down" followed by "docker-compose up -d".'
echo
echo '!! IMPORTANT !!'
echo
read -p "Press any key to continue..." < /dev/tty
fi
2019-03-14 08:46:15 +08:00
# Checking for old project name bug
2018-04-19 00:38:37 +08:00
sed -i 's#COMPOSEPROJECT_NAME#COMPOSE_PROJECT_NAME#g' mailcow.conf
2018-04-12 13:56:54 +08:00
2018-04-26 19:58:03 +08:00
echo -e "Fixing PHP-FPM worker ports for Nginx sites..."
2018-04-30 22:34:52 +08:00
sed -i 's#phpfpm:9000#phpfpm:9002#g' data/conf/nginx/*.conf
2018-04-28 03:23:00 +08:00
if ls data/conf/nginx/*.custom 1> /dev/null 2>& 1; then
2018-04-30 22:34:52 +08:00
sed -i 's#phpfpm:9000#phpfpm:9002#g' data/conf/nginx/*.custom
2018-04-28 03:23:00 +08:00
fi
2018-04-26 19:58:03 +08:00
2019-01-31 06:03:58 +08:00
# Fix Rspamd maps
if [ -f data/conf/rspamd/custom/global_from_blacklist.map ] ; then
mv data/conf/rspamd/custom/global_from_blacklist.map data/conf/rspamd/custom/global_smtp_from_blacklist.map
fi
if [ -f data/conf/rspamd/custom/global_from_whitelist.map ] ; then
mv data/conf/rspamd/custom/global_from_whitelist.map data/conf/rspamd/custom/global_smtp_from_whitelist.map
fi
2017-06-21 18:40:42 +08:00
echo -e "\e[32mStarting mailcow...\e[0m"
2017-06-21 22:53:36 +08:00
sleep 2
2018-02-02 04:51:23 +08:00
docker-compose up -d --remove-orphans
2017-07-08 22:22:48 +08:00
2019-02-01 04:55:49 +08:00
if [ [ -f "data/web/nextcloud/occ" ] ] ; then
echo "Setting Nextcloud Redis timeout to 0.0..."
docker exec -it -u www-data $( docker ps -f name = php-fpm-mailcow -q) bash -c "/web/nextcloud/occ config:system:set redis timeout --value=0.0 --type=integer"
fi
2017-07-08 22:31:08 +08:00
echo -e "\e[32mCollecting garbage...\e[0m"
2018-07-25 07:08:12 +08:00
docker_garbage
2017-07-08 22:22:48 +08:00
2017-07-05 03:28:27 +08:00
#echo "In case you encounter any problem, hard-reset to a state before updating mailcow:"
#echo
#git reflog --color=always | grep "Before update on "
#echo
#echo "Use \"git reset --hard hash-on-the-left\" and run docker-compose up -d afterwards."